Subject: bug#15899: 24.3.50; regression: `region' overlay is lower priority than default

From: Eli Zaretskii <[email-masked]>
Date: Fri, 15 Nov 2013 21:33:23 +0200

> Date: Fri, 15 Nov 2013 09:14:37 -0800 (PST)
> From: Drew Adams <[email-masked]>
> Cc: [email-masked], [email-masked]
> 
> > > This change should be reverted as soon as possible.
> > 
> > It needs not be reverted, I think.  We just need to make the
> > priority of the region overlay higher than any other overlay.
> 
> 1. I meant that the change to the behavior of the region not
> appearing "on top of" other highlighting (except isearch) needs
> to be reverted (undone).

You cannot revert behavior, only the code.  If the new implementation
has unwanted side effects, those side effects need to be fixed by
further changes.

> 2. Region highlighting should *not* be higher priority than
> all other overlays.  It should not be higher than isearch
> highlighting, for instance.  There might be other exceptions
> too; dunno.  See my previous mail.

I don't disagree.  If there are other overlays that should show
through the region, they should have higher priority.

> 4. If it was in fact a bug, it's not clear why the fix for it
> needed to involve changing region highlighting to use an
> overlay.  Not clear to me anyway.

It doesn't have to be clear.  The fact that region highlighting now
uses an overlay is an implementation detail.  Bug reports should
generally remain on the level of behavior, i.e. requirements, they
should not normally go to the implementation level.  The implementors
should have freedom to implement the required behavior as they see
fit, as long as the results are reasonable.

> My suggestion is to first revert the code change and then
> discuss what the bug is that it was intended to fix.  If
> there is really a bug that needs fixing, then let's please
> try to find some other, non-shotgun fix for it.

Again, please stay on the level of required behavior, and leave the
implementation out of this discussion.  As long as there's no evidence
that the new implementation cannot possibly accommodate the required
behavior, the implementation can stay.

> There should be no need to change the longstanding behavior
> of the Emacs region just because someone's highlighting does
> not show through.

Agreed.